/*
 * File         : ControlMessage.h
 * Author       : Pawel Roman
 * Created      : Tue Aug  5 19:56:46 1997
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1997/08/10 22:49:32 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#ifndef __CONTROLMESSAGE_H
#define __CONTROLMESSAGE_H

#include <Message.h>

class ControlCenter;

template<class HEADER>
class ControlMessage
   : public Message<HEADER>
{
   public:
      ControlMessage( const HEADER& hd, ControlCenter* cc );

   protected:
      ControlCenter* control;
};

template<class HEADER>
inline ControlMessage<HEADER>::
ControlMessage( const HEADER& hd, ControlCenter* cc )
   : Message<HEADER>( hd ), control( cc )
{
   ACE_TRACE( "(ControlMessage::ControlMessage)" );
}

#endif

