/*
 * File:       ViewerLinkHandler.h
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    Sun Apr 27 1997
 * Revision:   $Revision: 1.3 $
 * Updated:    $Date: 1997/08/10 22:49:34 $
 * Copyright 1997 NPAC, Syracuse University
 *
 */

#ifndef _VIEWERLINKHANDLER_H
#define _VIEWERLINKHANDLER_H

#include <ace/Event_Handler.h>
#include <ace/LSOCK_Stream.h>
#include <ace/Message_Block.h>

#include <MsgHeader.h>

class ControlCenter;

class ViewerLinkHandler : public ACE_Event_Handler
{
   public:
      typedef ACE_LSOCK_Stream IPC_SAP;

      ViewerLinkHandler( ControlCenter& ctrl, ACE_HANDLE fd );
      int handle_input( ACE_HANDLE );
      int handle_close( ACE_HANDLE, ACE_Reactor_Mask );
      ACE_HANDLE get_handle( void ) const;
      void set_handle( ACE_HANDLE handle );
      int send_msg( MsgHeader<IPC_SAP>& header, ACE_Message_Block& mb );
      
   private:
      IPC_SAP sap;
      MsgHeader<IPC_SAP> header;
      ControlCenter& control;
};

inline ACE_HANDLE ViewerLinkHandler::
get_handle( void ) const
{
   ACE_TRACE( "(ViewerLinkHandler::get_handle)" );
   return sap.get_handle();
}

inline void ViewerLinkHandler::
set_handle( ACE_HANDLE fd )
{
   ACE_TRACE( "(ViewerLinkHandler::set_handle)" );
   sap.set_handle( fd );
}

inline int ViewerLinkHandler::
handle_close( ACE_HANDLE, ACE_Reactor_Mask )
{
   ACE_TRACE( "(ViewerLinkHandler::handle_close)" );
   ACE_DEBUG(( LM_DEBUG, "fd: %d\n", sap.get_handle() ));
   return close( sap.get_handle() );
}

#endif
