/*
 * File         : msgFOCUS.h
 * Author       : Pawel Roman
 * Created      : Tue Aug  5 19:47:14 1997
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/07/07 12:20:54 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#ifndef __MSGFOCUS_H
#define __MSGFOCUS_H

#include "ControlProto.h"
#include "ControlMessage.h"

template<class HEADER>
class msgFOCUS : public ControlMessage<HEADER>
{
   public:
      msgFOCUS( ControlCenter* cc );
      MRESULT read( const SAP& sap, const Header& header );
      MRESULT write( const SAP& sap );
      MRESULT set( const void* params = NULL );
      void execute( void );
};

template<class HEADER>
inline msgFOCUS<HEADER>::
msgFOCUS( ControlCenter* cc )
   : ControlMessage<HEADER>( Header( FOCUS, 0, 0 ), cc )
{ 
   ACE_TRACE( "(msgFOCUS::msgFOCUS)" );
}

template<class HEADER>
inline msgFOCUS<HEADER>::MRESULT msgFOCUS<HEADER>::
read( const SAP&, const Header& )
{
   ACE_TRACE( "(msgFOCUS::read)" );
   return OK_RES;
}

template<class HEADER>
inline msgFOCUS<HEADER>::MRESULT msgFOCUS<HEADER>::
write( const SAP& sap ) 
{ 
   ACE_TRACE( "(msgFOCUS::write)" );
   if( header.write( sap ) == Header::LINK_OK )
      return OK_RES;
   
   return END_RES;
}

template<class HEADER>
inline msgFOCUS<HEADER>::MRESULT msgFOCUS<HEADER>::
set( const void* ) 
{ 
   ACE_TRACE( "(msgFOCUS::set)" );
   return OK_RES;
}

template<class HEADER>
inline void msgFOCUS<HEADER>::
execute( void )
{
   ACE_TRACE( "(msgFOCUS::execute)" );
   Widget w = control->getWidget();
   
//   XRaiseWindow(XtDisplay(w), XtWindow(w));
   XMapRaised(XtDisplay(w), XtWindow(w));
}

#endif

