/*
 * File         : msgCSYNCR.h
 * Author       : Pawel Roman
 * Created      : Tue Aug  5 19:47:14 1997
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1997/08/10 22:49:13 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#ifndef __MSGCSYNCR_H
#define __MSGCSYNCR_H

#include "ControlProto.h"
#include "ControlMessage.h"

template<class HEADER>
class msgCSYNCR : public ControlMessage<HEADER>
{
   public:
      msgCSYNCR( ControlCenter* cc );
      MRESULT read( const SAP& sap, const Header& header );
      MRESULT write( const SAP& sap );
      MRESULT set( const void* params = NULL );
      void execute( void );
};

template<class HEADER>
inline msgCSYNCR<HEADER>::
msgCSYNCR( ControlCenter* cc )
   : ControlMessage<HEADER>( Header( CSYNCR, 0, 0 ), cc )
{ 
   ACE_TRACE( "(msgCSYNCR::msgCSYNCR)" );
}

template<class HEADER>
inline msgCSYNCR<HEADER>::MRESULT msgCSYNCR<HEADER>::
read( const SAP&, const Header& )
{
   ACE_TRACE( "(msgCSYNCR::read)" );
   return OK_RES;
}

template<class HEADER>
inline msgCSYNCR<HEADER>::MRESULT msgCSYNCR<HEADER>::
write( const SAP& sap ) 
{ 
   ACE_TRACE( "(msgCSYNCR::write)" );
   if( header.write( sap ) == Header::LINK_OK )
      return OK_RES;
   
   return END_RES;
}

template<class HEADER>
inline msgCSYNCR<HEADER>::MRESULT msgCSYNCR<HEADER>::
set( const void* ) 
{ 
   ACE_TRACE( "(msgCSYNCR::set)" );
   return OK_RES;
}

template<class HEADER>
inline void msgCSYNCR<HEADER>::
execute( void )
{
   ACE_TRACE( "(msgCSYNCR::execute)" );
   control->sendSynchro();
}

#endif

