/*
 * File:       taz.C
 * Author:     Pawel Roman (proman@npac.syr.edu)
 * Created:    Mon Apr 21 1997
 * Revision:   $Revision: 1.4 $
 * Updated:    $Date: 1998/04/25 06:15:01 $
 * Copyright 1997 NPAC, Syracuse University
 *
 */

#include <fstream.h>
#include "ControlCenter.h"

#ifndef ACE_NLOGGING
static const char* LOG_DIR = "/tmp/GIS_cache";
static const char* LOG_PREFIX = "TAZ_";
#endif

int
main( int argc, char* argv[] )
{
#ifndef ACE_NLOGGING
   static const int CF_MODE = 0666;
   char* tempfile = tempnam( LOG_DIR, LOG_PREFIX );
   ofstream log( tempfile );
   chmod( tempfile, CF_MODE );
   ACE_LOG_MSG->set_flags( ACE_Log_Msg::OSTREAM );
   ACE_LOG_MSG->msg_ostream( &log );
   ACE_LOG_MSG->clr_flags( ACE_Log_Msg::STDERR );
   ACE_LOG_MSG->start_tracing();
#else
   ACE_LOG_MSG->clr_flags( ACE_Log_Msg::STDERR );
#endif

   ControlCenter conrol( argc, argv );
   return 0;
}
